import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class NonlinearNewton extends Frame
{  public int Iter,Itermax; public double Err;
   public NonlinearNewton()
   {  setSize(800,300);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double[][] setJACOBI(double[] A)
   {  double [][]JACOBI = new double[2][3]; // Jacobianݒ
      JACOBI[0][0] = 2 * A[0] +     A[1];
      JACOBI[0][1] =     A[0] + 2 * A[1];
      JACOBI[1][0] =  1;
      JACOBI[1][1] = -1;
      // - f(X)  ֐l̐ݒ
      JACOBI[0][2] = -(A[0] * A[0] + A[0] * A[1] + A[1] * A[1] - 1);
      JACOBI[1][2] = -(A[0] - A[1]);
      return JACOBI;
   }
   public double[] solution(double EPS)
   { int i; double D;
     double [][]JACOBI; int N = 2;
     double [] A={1,1};
     Iter= 0; Itermax = 100; Err = EPS * 100;
     while(Err > EPS && Iter < Itermax)
     { Iter++; JACOBI= setJACOBI(A);
       if(SimEq(JACOBI, N, EPS) != 0) break; 
       Err = 0;
       for(i=0;i<N;i++)
       {  D     = JACOBI[i][N]; Err  += D * D;
          A[i] += JACOBI[i][N];
       }
      }
      return A;
   }
   public int SimEq(double [][] A, int N, double Eps)
   {   int i,j,k; double Alfa; int N1=N+1;   
       for(k = 0; k < N; k++)     // Oi   
       { int k1=k+1; 
         double max=Math.abs(A[k][k]); int IR = k;  //s{bgI
         if(k != N) for(i=k1;i<N; i++)if(Math.abs(A[i][k])>max){max=Math.abs(A[i][k]);IR=i;}
         if(max < Eps) return 1;
         if(IR !=k ) for(j=k; j<N1;j++){Alfa=A[k][j]; A[k][j]=A[IR][j];A[IR][j]=Alfa;}
         for(i=k+1; i<N; i++)
         { Alfa= A[i][k] / A[k][k];
           for(j = k + 1;j <= N; j++)  A[i][j] -= Alfa * A[k][j];
       } }
       for(i = N-1; i >= 0; i--)   // ޑ
       {   Alfa = A[i][N];
           for(j = i + 1; j < N; j++) Alfa -= A[i][j] * A[j][N];
           A[i][N] = Alfa / A[i][i];
       }
       return 0;
   }
   public void paint(Graphics g)
   {  setTitle("A`");
      double[] A = solution(0.001);
      g.drawString( " x0 = " + A[0] + "    x1 = " + A[0], 20, 50);
      g.drawString( "JԂ = "+Iter + "    덷 = " + Err,20,80);
   } 
   public static void main(String[] args)
   {  Frame w = new NonlinearNewton();
      w.setVisible(true);
   }
}
